#!/usr/bin/env python
import inspect


def getsubclasses(cls, depth=None):
    """class subclasses

    Returns list
    """
    if not cls:
        return []
    if not inspect.isclass(cls):
        cls = cls.__class__
    if not depth:
        depth = 999
    if depth == 1:
        return type.__subclasses__(cls)
    else:
        if not inspect.isclass(cls):
            cls = cls.__class__
        _subclasses = getsubclasses(cls, 1)
        for subcls in _subclasses:
            _subclasses += getsubclasses(subcls, depth - 1)
        return _subclasses
